#!/usr/bin/perl
######################################################################
# Form 2 Mail                             Version 1.0                #
# Copyright 1999 Frederic TYNDIUK (FTLS)  All Rights Reserved.       #
# E-Mail: tyndiuk@ftls.org                Script License: GPL        #
# Created  10/22/99                       Last Modified 11/07/99     #
# Scripts Archive at:                     http://www.ftls.org/cgi/   #
######################################################################
# Function :                                                         #
# Send Form data to your E-Mail                                      #
######################################################################
##################### license & copyright header #####################
#                                                                    #
#                 Copyright (c) 1999 TYNDIUK Frederic                #
#                                                                    #
#  This program is free software; you can redistribute it and/or     #
#  modify it under the terms of the GNU General Public License as    #
#  published by the Free Software Foundation; either version 2 of    #
#  the License, or (at your option) any later version.               #
#                                                                    #
#  This program is distributed in the hope that it will be useful,   #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of    #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     #
#  GNU General Public License for more details.                      #
#                                                                    #
#  You should have received a copy of the GNU General Public License #
#  along with this program in the file 'COPYING'; if not, write to   #
#  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,  #
#  Boston, MA 02111-1307, USA, or contact the author:                #
#                                                                    #
#                              TYNDIUK Frederic <tyndiuk@ftls.org>   #
#                                       <http://www.ftls.org/>       #
#                                                                    #
################### end license & copyright header ###################
######################################################################
# Necessary Variables:                                               #
# The following variables should be set to define the locations      #
# and URLs of various files, as explained in the documentation.      #

require "cgi-lib.pl";

$Mail_To = 'you@foo.com';
$Mail_From = 'webmaster@foo.com';
$Mail_Webmaster = 'webmaster@foo.com';

$MAIL_CMD = '/usr/sbin/sendmail -t';
$USE_SENDMAIL_UNIX = 1;
	# En : 1 Use unix sendmail command, 0 use Mail::Mailer module
	# Fr : 1 utilise la commande sendmail unix, 0 utilise le module Mail::Mailer
#use Mail::Mailer;
	# En: Only if you don't use Sendmail, 
    # Fr : Seulement si vous n'utilisez pas senmail

$USE_HTML_MailTo = 0;  # 1 Yes/Oui, 0 No/Non
	# En : Can Keep Reciept E-Mail from HTML Form, Warnig, it's dangerous...
	# Fr : Autorise de prendre l'E-Mail de reception dans le formulaire HTML.

# En : Common data for HTML Result
# Fr : Donne page resultat
$HTML_Title = 'Thanks';
$HTML_Message_Begin = '';
$HTML_Message_End = '';
$HTML_Back_Button = 'Back';
$HTML_Display_Data = 1; # 1 Yes/Oui, 0 No/Non
	# En : Display submited data into HTML result page ?
	# Fr : Affiche les donnee envoyee dans la page resultat ?

# En : Common data for Mail message 
# Fr : Donne pour le Mail
$Mail_Subject = 'Informations from your form';
$Mail_Message_Begin = '';
$Mail_Message_End = '';

$INVALID_MAIL_SENDER_ADDRESS_MESSAGE = 'Error : Invalid Mail sender Adress : ';

@REFERERS    = ('http://www.foo.com');

# Nothing Below this line needs to be altered!                       #
######################################################################

	&CheckReferer(@REFERERS);

	if ($ENV{'REQUEST_METHOD'} eq "POST" ) {
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	} else {
		$buffer = $ENV{'QUERY_STRING'};
	}
	$i = 0;
	@pairs = split(/&/, $buffer);
	foreach $pair (@pairs) {
		($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%(..)/pack("C", hex($1))/eg;
		if ($USE_HTML_MailTo && ($name eq "Mail_To") && &ControlMail($value)) { $Mail_To = $value; $name = "To"; }
		if ($name eq "Mail_From" && &ControlMail($value)) { $Mail_From = $value; $name = "From" }
		if ($name eq "Mail_Subject")       { $Mail_Subject = $value; }
		if ($name eq "Mail_Message_Begin") { $Mail_Message_Begin = $value; }
		if ($name eq "Mail_Message_End")   { $Mail_Message_End = $value; }
		if ($name eq "HTML_Title")         { $HTML_Title = $value; }
		if ($name eq "HTML_Message_Begin") { $HTML_Message_Begin = $value; }
		if ($name eq "HTML_Message_End")   { $HTML_Message_End = $value; }
		if ($name eq "HTML_Back_Button")   { $HTML_Back_Button = $value; }
		if ( ($name eq "HTML_Display_Data") && ($value =~ /No/i))  { $HTML_Display_Data = 0; }
		if ( ($name ne "Mail_Message_Begin") && ($name ne "Mail_Subject") &&
			 ($name ne "Mail_Message_End")   && ($name ne "HTML_Title")   &&
			 ($name ne "HTML_Message_Begin") && ($name ne "HTML_Message_End") &&
			 ($name ne "HTML_Back_Button")   && ($name ne "HTML_Display_Data") ) {
			$name =~ s/_/ /g;
			$TAB[$i][0] = $name;
			$TAB[$i][1] = $value;
			$i++;
		}
	}

	print "Content-type: text/html\n\n";
    print &HTMLHeaderTitle("Informations transmises");

	print $HTML_Message_Begin;

    print "<TABLE BORDER=0 WIDTH=\"80%\" ALIGN=\"CENTER\">";
	$data = "    Date : \t".&Date."\n";
	foreach (@TAB) {
		$match = $$_[0];
		$value = $$_[1];
		$match =~ s/_/ /g;
		$data .= "    $match : \t$value\n";
		if ($HTML_Display_Data) { print  "<TR><TD WIDTH=\"30%\">$match :</TD><TD><B> $value</B></TD></TR>\n"; }
	}
	print "</TABLE>\n";
	if (&ControlMail($Mail_To)) {
		&SendMail($Mail_To, $Mail_From, $Mail_Subject, $Mail_Message_Begin.$data.$Mail_Message_End);
	} else {
		print "<CENTER><B>$INVALID_MAIL_SENDER_ADDRESS_MESSAGE $Mail_To</B></CENTER>";
	}

	print $HTML_Message_End;
	
	print &Back($ENV{'HTTP_REFERER'}, $HTML_Back_Button);

	print &HTMLEnd;

###############################################################################
# Sub
###############################################################################

sub SendMail {
	my($to, $from, $subject, $message) = @_;
	if ($USE_SENDMAIL_UNIX) {
		open(MAIL,"|$MAIL_CMD $to") ||  print("Could not execute \"$MailCMD\"");
		print MAIL <<End_of_Mail;
X-Mailer: form2mail v1.0 (From $ENV{'HTTP_REFERER'})
From: $from
X-Ident-From: unknown
Subject: $subject
To: $to
Precedence: bulk

$message
End_of_Mail
		close(MAIL);
	} else {
		$mailer = Mail::Mailer->new();
		$mailer->open({ From => $from, To => $to, Subject => $subject }) || die "Can't open: $!\n";
 		print $mailer $message;
	}
}

sub ControlMail {
	my($email) = @_;
	if ($email =~ /;/) { return 0; }
	return $email =~ /.+@.+\.\w+\s*$/;
}


sub Date {
	my($Day,$Month,$Year) = (localtime(time))[3..5];
	$Year += 1900; $Month++;
	if ($Day < 10) { $Day = "0".$Day; }
	if ($Month < 10) { $Month = "0".$Month; }
	return "$Month/$Day/$Year";
}

sub CheckReferer {
	my($referer);
	if (defined $ENV{'HTTP_REFERER'}) {
		foreach $referer (@_) {
			if ($ENV{'HTTP_REFERER'} =~ /^$referer/i) {
				return;
        	}
		}
	}
	print &PrintHeader;
    print &HTMLHeaderTitle("Unauthorized access to: $ENV{'HTTP_REFERER'}");
    print &HTMLEnd;
	exit;
}

sub HTMLHeaderTitle {
	return &HTMLHeader($_[0]).&Title($_[0]);
}

sub HTMLHeader {
	my $title = $_[0];
	$title =~ s/\<\w\w*\>/ /gi;
    return <<EOF;
<HTML><HEAD><TITLE>$title</TITLE>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">
<META NAME="ROBOTS" CONTENT="NOINDEX, FOLLOW">
<META NAME="description" content="none">
<META NAME="keywords" content="none">
<META NAME="Author" CONTENT="FTLS (TYNDIUK Frederic, ftls\@ftls.org, http://www.ftls.org/)">
<META NAME="GENERATOR" CONTENT="CGI Script Made by FTLS"></HEAD>
<BODY BGCOLOR="#FFFFFF">
EOF
}

sub Title {
    return <<EOF;
<BR><BR><P ALIGN="Center"><FONT FACE="Arial, helvetica" SIZE="+2" COLOR="#336699"><STRONG><EM>$_[0]</EM></STRONG></FONT></P><BR>
EOF
}

sub Back {
    if ($_[1] eq "") { $_[1] = "Back"; }
    return <<EOF;
<CENTER><BR><BR><FONT FACE="Arial"><A HREF="$_[0]">$_[1]</A><BR><BR></CENTER>
EOF
}

sub HTMLEnd {
    return <<EOF;
<CENTER><BR><BR>
	<FONT FACE="Arial" SIZE=-2>
	<EM>&copy Copyright 1999 <A HREF="http://www.ftls.org/">FTLS</A> (<A HREF="mailto:ftls\@ftls.org">Tyndiuk Fr&eacute;d&eacute;ric</A>). All rights reserved.
	<BR>Send all comments to <A HREF="mailto:$Mail_Webmaster">$Mail_Webmaster</A>
	<BR>FTLS's CGI Scripts Archive : <A HREF="http://www.ftls.org/cgi/">http://www.ftls.org/cgi/</A></EM>
	</FONT>
</CENTER>
</BODY></HTML>
EOF
}
